cb27559cdf55f1612b8a8a271af39741ced45b97
[xfstests-dev.git] / tests / xfs / 094
1 #! /bin/bash
2 # FS QA Test No. 094
3 #
4 # Exercising the inheritable realtime inode bit.
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2005 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=1        # failure is the default!
32 trap "_cleanup; exit \$status" 0 1 2 3 15
33
34 _cleanup()
35 {
36     cd /
37     rm -f $tmp.*
38 }
39
40 # get standard environment, filters and checks
41 . ./common/rc
42 . ./common/filter
43
44 # real QA test starts here
45 _supported_fs xfs
46 _supported_os IRIX Linux
47 _require_realtime
48 _require_scratch
49 _require_command $XFS_IO_PROG xfs_io
50
51 _filter_realtime_flag()
52 {
53         _test_inode_flag realtime $SCRATCH_MNT/testdir/$1
54         if [ $? -eq 0 ]; then
55                 echo "--r-- SCRATCH_MNT/testdir/$1"
56         else
57                 echo "----- SCRATCH_MNT/testdir/$1"
58         fi
59 }
60
61 _filter_rtinherit_flag()
62 {
63         _test_inode_flag rt-inherit $SCRATCH_MNT/testdir
64         if [ $? -eq 0 ]; then
65                 echo "--t-- SCRATCH_MNT/testdir"
66         else
67                 echo "----- SCRATCH_MNT/testdir"
68         fi
69 }
70
71 _create_scratch()
72 {
73         echo "*** mkfs"
74         if ! _scratch_mkfs_xfs >$tmp.out 2>&1
75         then
76                 cat $tmp.out
77                 echo "failed to mkfs $SCRATCH_DEV"
78                 exit 1
79         fi
80
81         echo "*** mount"
82         if ! _scratch_mount
83         then
84                 echo "failed to mount $SCRATCH_DEV"
85                 exit 1
86         fi
87 }
88
89 _create_scratch
90 mkdir $SCRATCH_MNT/testdir
91
92 # set inode attribute, create files below and check they're marked realtime
93 # unset inode attribute, create files below and check they're not realtime
94
95 echo "*** create directory with rtinherit"
96 $XFS_IO_PROG -r -c 'chattr +t' $SCRATCH_MNT/testdir
97 _filter_rtinherit_flag
98
99 echo "*** create child with inherited realtime"
100 touch $SCRATCH_MNT/testdir/real
101 _filter_realtime_flag real
102
103 echo "*** remove rtinherit from directory"
104 $XFS_IO_PROG -r -c 'chattr -t' $SCRATCH_MNT/testdir
105 _filter_rtinherit_flag
106
107 echo "*** create child without inherited realtime"
108 touch $SCRATCH_MNT/testdir/unreal
109 _filter_realtime_flag unreal
110
111 echo "*** done"
112
113 # success, all done
114 status=0
115 exit